// Copyright (c) Shenyang Leading Edge Intelligent Technology Co., Ltd. All rights reserved.

package implments

import (
	"LAPP_ACURA_MOM_BACKEND/grmi"
	meta "LAPP_ACURA_MOM_BACKEND/meta/base"
	model "LAPP_ACURA_MOM_BACKEND/models/base"
	"fmt"
	"github.com/go-xorm/xorm"
	"xorm.io/core"
)

/******************************************************************************
 *
 * @Struct Name              : LabelTemplateDetailDAOImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : LabelTemplateDetail的数据访问对象实现
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-11-25 16:19:35
 *
 ******************************************************************************/
type LabelTemplateDetailDAOImplement struct {
	session *xorm.Session
	meta    *grmi.Entity
	plantNr int
	userid  string
}

/******************************************************************************
 *
 * @Function Name            : NewLabelTemplateDetailDAOImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : 创建一个LabelTemplateDetailDAOImplement实例
 *
 * @Function Parameters      : xorm会话
 *
 * @Function Parameters      : 基本主键
 *
 * @Return Value             : LabelTemplateDetailDAOImplement实例
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-11-25 16:19:35
 *
 ******************************************************************************/
func NewLabelTemplateDetailDAOImplement(session *xorm.Session, plantNr int, userid string) *LabelTemplateDetailDAOImplement {
	return &LabelTemplateDetailDAOImplement{session, &meta.LabelTemplateDetail, plantNr, userid}
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/base/LabelTemplateDetailDAO.InsertOne
 *
 ******************************************************************************/
func (impl *LabelTemplateDetailDAOImplement) InsertOne(entity *model.LabelTemplateDetail) error {
	entity.PlantNr = impl.plantNr
	entity.LastUser = impl.userid
	_, err := impl.session.Table(impl.meta.TableName).Insert(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/base/LabelTemplateDetailDAO.DeleteOne
 *
 ******************************************************************************/
func (impl *LabelTemplateDetailDAOImplement) DeleteOne(labelTemplateId string, pos int) error {
	_, err := impl.session.Table(impl.meta.TableName).ID(core.PK{impl.plantNr, labelTemplateId, pos}).Delete(impl.meta.Indicator)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}

	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/base/LabelTemplateDetailDAO.SelectOne
 *
 ******************************************************************************/
func (impl *LabelTemplateDetailDAOImplement) SelectOne(labelTemplateId string, pos int) (*model.LabelTemplateDetail, error) {
	var data model.LabelTemplateDetail
	ok, err := impl.session.Table(impl.meta.TableName).ID(core.PK{impl.plantNr, labelTemplateId, pos}).Get(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	if !ok {
		return nil, nil
	}
	return &data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/base/LabelTemplateDetailDAO.UpdateOne
 *
 ******************************************************************************/
func (impl *LabelTemplateDetailDAOImplement) UpdateOne(entity *model.LabelTemplateDetail) error {
	entity.PlantNr = impl.plantNr
	entity.LastUser = impl.userid
	_, err := impl.session.Table(impl.meta.TableName).Cols(impl.meta.UpdatingMembers...).ID(entity.GetKey()).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/base/LabelTemplateDetailDAO.Insert
 *
 ******************************************************************************/
func (impl *LabelTemplateDetailDAOImplement) Insert(entities *[]model.LabelTemplateDetail) error {
	for i := 0; i < len(*entities); i++ {
		entity := &(*entities)[i]
		entity.PlantNr = impl.plantNr
		entity.LastUser = impl.userid
	}
	_, err := impl.session.Table(impl.meta.TableName).Insert(entities)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/base/LabelTemplateDetailDAO.Delete
 *
 ******************************************************************************/
func (impl *LabelTemplateDetailDAOImplement) Delete(entities *[]model.LabelTemplateDetail) error {
	for _, entity := range *entities {
		entity.PlantNr = impl.plantNr
		_, err := impl.session.Table(impl.meta.TableName).ID(entity.GetKey()).Delete(impl.meta.Indicator)
		if err != nil {
			return grmi.NewDataBaseError(err)
		}
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/base/LabelTemplateDetailDAO.DeleteWhere
 *
 ******************************************************************************/
func (impl *LabelTemplateDetailDAOImplement) DeleteWhere(predicates []grmi.Predicate) error {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.LabelTemplateDetail_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	_, err := session.Delete(impl.meta.Indicator)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/base/LabelTemplateDetailDAO.Select
 *
 ******************************************************************************/
func (impl *LabelTemplateDetailDAOImplement) Select(predicates []grmi.Predicate, orderByFields []grmi.Field) ([]model.LabelTemplateDetail, error) {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.LabelTemplateDetail_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	session = session.OrderBy(meta.LabelTemplateDetail_PlantNr.ColumnName)
	if orderByFields != nil {
		for _, field := range orderByFields {
			session = session.OrderBy(field.ColumnName)
		}
	}

	data := make([]model.LabelTemplateDetail, 0, 10)
	err := session.Find(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	return data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/base/LabelTemplateDetailDAO.SelectCols
 *
 ******************************************************************************/
func (impl *LabelTemplateDetailDAOImplement) SelectCols(predicates []grmi.Predicate, orderByFields []grmi.Field, cloumns []string) ([]model.LabelTemplateDetail, error) {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.LabelTemplateDetail_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	session = session.OrderBy(meta.LabelTemplateDetail_PlantNr.ColumnName)
	if orderByFields != nil {
		for _, field := range orderByFields {
			session = session.OrderBy(field.ColumnName)
		}
	}

	data := make([]model.LabelTemplateDetail, 0, 10)
	err := session.Cols(cloumns...).Find(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	return data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/base/LabelTemplateDetailDAO.SelectAndPaging
 *
 ******************************************************************************/
func (impl *LabelTemplateDetailDAOImplement) SelectAndPaging(paging *grmi.Paging, predicates []grmi.Predicate, orderByFields []grmi.Field) (grmi.PagingResult, error) {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.LabelTemplateDetail_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	count, err := session.Count(impl.meta.Indicator)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}

	orderBy := " order by " + meta.LabelTemplateDetail_PlantNr.ColumnName
	if orderByFields != nil {
		for _, field := range orderByFields {
			if orderBy == " order by " {
				orderBy += field.ColumnName
			} else {
				orderBy += ", " + field.ColumnName
			}
		}
	}
	parameters = append(parameters, paging.Offset(), paging.Size)
	data := make([]model.LabelTemplateDetail, 0, 10)
	where = " where " + where
	err = impl.session.Table(impl.meta.TableName).SQL("select * from ["+impl.meta.TableName+"]"+where+orderBy+" offset ? row fetch next ? row only", parameters...).Find(&data)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}
	return grmi.PagingResult{Records: data, Count: count, PageNumber: paging.Number, PageSize: paging.Size}, nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/base/LabelTemplateDetailDAO.Update
 *
 ******************************************************************************/
func (impl *LabelTemplateDetailDAOImplement) Update(entities *[]model.LabelTemplateDetail) error {
	for i := 0; i < len(*entities); i++ {
		entity := &(*entities)[i]
		entity.PlantNr = impl.plantNr
		entity.LastUser = impl.userid
		_, err := impl.session.Table(impl.meta.TableName).Cols(impl.meta.UpdatingMembers...).ID(entity.GetKey()).Update(entity)
		if err != nil {
			return grmi.NewDataBaseError(err)
		}
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/base/LabelTemplateDetailDAO.UpdateWhere
 *
 ******************************************************************************/
func (impl *LabelTemplateDetailDAOImplement) UpdateWhere(predicates []grmi.Predicate, entity *model.LabelTemplateDetail, columns ...string) error {

	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.LabelTemplateDetail_PlantNr.ColumnName)

	session := impl.session.Table(impl.meta.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	columns = append(columns, meta.LabelTemplateDetail_LastUser.Name)
	entity.LastUser = impl.userid
	_, err := session.Cols(columns...).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_ACURA_MOM_BACKEND/dao/base/LabelTemplateDetailDAO.UpdateWhere
 *
 ******************************************************************************/
func (impl *LabelTemplateDetailDAOImplement) SelectAllTemplate() ([]model.LabelTemplateHead, error) {
	parameters := []interface{}{impl.plantNr}
	where := fmt.Sprintf("%s = ?", meta.LabelTemplateDetail_PlantNr.ColumnName)
	condition := fmt.Sprintf("%s = %s and %s = %s",
		meta.LabelTemplateDetail_PlantNr.ColumnName,
		meta.LabelTemplateHead_PlantNr.ColumnName,
		meta.LabelTemplateDetail_LabelTemplateId.ColumnName,
		meta.LabelTemplateHead_LabelTemplateId.ColumnName)
	data := make([]model.LabelTemplateData, 0)
	session := impl.session.Table(impl.meta.TableName).Join("LEFT", meta.LabelTemplateHead.TableName, condition).Where(where, parameters...)
	err := session.OrderBy(meta.LabelTemplateDetail_LabelTemplateId.ColumnName).OrderBy(meta.LabelTemplateDetail_Pos.ColumnName).Find(&data)
	if err != nil {
		return nil, err
	}
	result := make([]model.LabelTemplateHead, 0)
	var templateId string
	var currentTemplateHead model.LabelTemplateHead
	for _, item := range data {
		if templateId == "" {
			templateId = item.LabelTemplateHead.LabelTemplateId
			currentTemplateHead = item.LabelTemplateHead
			currentTemplateHead.LabelTemplateDetail = make([]model.LabelTemplateDetail, 0)
		}
		if templateId != item.LabelTemplateHead.LabelTemplateId {
			result = append(result, currentTemplateHead)
			templateId = item.LabelTemplateHead.LabelTemplateId
			currentTemplateHead = item.LabelTemplateHead
			currentTemplateHead.LabelTemplateDetail = make([]model.LabelTemplateDetail, 0)
		}
		currentTemplateHead.LabelTemplateDetail = append(currentTemplateHead.LabelTemplateDetail, item.LabelTemplateDetail)
	}
	result = append(result, currentTemplateHead)
	return result, nil
}